import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.*;

import java.awt.Font;

import java.awt.Color;


public class FileVerifier extends JFrame implements ActionListener {
	private static final long serialVersionUID = 8999335187627296323L;
	public int wd0, ht0, wd1, ht1, wd2, ht2, wd3, ht3;
	public int nx,ny;

	public int count=0;
	public int imode=0;
	public int execute=0;
	public String text1,text2,text3;

	public String selectedFilePath1="";
	public String selectedFileName1="";
	public String selectedFilePath2="";
	public String selectedFileName2="";
	public String resizeFilePath="";
	public String selectedFolderName1="";
	public String selectedFolderName2="";
	public String lastFileName1="";
	public String lastFileName2="";
	
	public JPanel p1;
	public JLabel plate1, plate2;
	public JLabel and1,and2,and3;
	public JLabel label1,label2,label3,label4;
	public JLabel label5,label6,label7,label8;
	public JLabel label9,label10,label11,label12;
	
	public JButton btn1,btn2,btn3,btn4,btn5,btn6;
	public JTextArea ta1,ta2,ta3;
	public JTextField tf1,tf2,tf3,tf4;
	public JScrollPane sc1,sc2;
	

	public String[] list1,list2;
	
	public byte[] buf1;
	public byte[] buf2;
	public int files1=0;
	public int files2=0;
	
	public int ncheck=0;
	
	public static void main(String[] args){
		FileVerifier app= new FileVerifier("FileVerifier Ver.1.0");
		int screenWidth=1000;
		int screenHeight=700;
		app.setSize(screenWidth + app.getInsets().left + app.getInsets().right, screenHeight + app.getInsets().top + app.getInsets().bottom);
	}
	
	public FileVerifier(String title)  {
		super(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

		list1=new String[1024];
		list2=new String[1024];
		int bw=120;

		
		p1 = new JPanel();
		
		p1.setBackground(new Color(144,234,120));
		p1.setLayout(null);
		
		plate1 = new JLabel(new ImageIcon("icons/fv1.png"));
		plate1.setBounds(160,10,600,80);
		p1.add(plate1);
		
		plate2 = new JLabel(new ImageIcon("icons/adcl.png"));
		plate2.setBounds(860,25,100,40);
		p1.add(plate2);

		btn1 = new JButton("フォルダ１選択");
		btn1.setBounds(40,80,bw,40);
		p1.add(btn1);
		btn1.addActionListener(this);
		
		btn2 = new JButton("フォルダ２選択");
		btn2.setBounds(40,130,bw,40);
		p1.add(btn2);
		btn2.addActionListener(this);
		
		btn3 = new JButton("ベリファイ実行");
		btn3.setBounds(850,80,bw,40);
		p1.add(btn3);
		btn3.addActionListener(this);
		
		btn4 = new JButton("同ファイル名",new ImageIcon("icons/check0.png"));
		btn4.setBounds(855,125,bw-10, 20);
		p1.add(btn4);
		btn4.addActionListener(this);
		/*
		btn4 = new JButton("ベリファイ実行");
		btn4.setBounds((bw+bs)*6+25,90,bw,40);
		p1.add(btn4);
		btn4.addActionListener(this);
		*/
		
		label1 = new JLabel("フォルダ１:");
		label1.setFont(new Font("DialogInput", Font.BOLD, 14));
		label1.setBounds(180,80,600,40);
		p1.add(label1);
		
		label2 = new JLabel("フォルダ２:");
		label2.setFont(new Font("DialogInput", Font.BOLD, 14));
		label2.setBounds(180,130,600,40);
		p1.add(label2);
		/*
		label3 = new JLabel("ベリファイ結果:");
		label3.setFont(new Font("DialogInput", Font.BOLD, 14));
		label3.setBounds(680,136,450,40);
		p1.add(label3);
		
		label3 = new JLabel("含まれる文字列1");
		label3.setBounds((tw+ts)*2+55,90,tw,15);
		p1.add(label3);
		
		and1 = new JLabel("&");
		and1.setBounds((tw+ts)*2+38+tw,110,15,15);
		p1.add(and1);
		
		label4 = new JLabel("含まれる文字列2");
		label4.setBounds((tw+ts)*3+45,90,tw,15);
		p1.add(label4);
		
		and2 = new JLabel("&");
		and2.setBounds((tw+ts)*3+38+tw,110,15,15);
		p1.add(and2);
		
		label5 = new JLabel("含まれる文字列3");
		label5.setBounds((tw+ts)*4+45,90,tw,15);
		p1.add(label5);
		
		tf1=new JTextField("");
		tf1.setBounds((tw+ts)*2+40,105,tw,25);
		p1.add(tf1);
		
		tf2=new JTextField("");
		tf2.setBounds((tw+ts)*3+40,105,tw,25);
		p1.add(tf2);
		
		tf3=new JTextField("");
		tf3.setBounds((tw+ts)*4+40,105,tw,25);
		p1.add(tf3);
		*/
		
		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(30,180,300,500);
		p1.add(sc1);
		
		ta2 = new JTextArea("");
		JScrollPane sc2 = new JScrollPane();
		sc2.setViewportView(ta2);
		sc2.setBounds(350,180,300,500);
		p1.add(sc2);
		
		ta3 = new JTextArea("");
		JScrollPane sc3 = new JScrollPane();
		sc3.setViewportView(ta3);
		sc3.setBounds(670, 180, 300,500);
		p1.add(sc3);
		
		getContentPane().add(p1, BorderLayout.CENTER);

		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    text1="";
	}
	
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == btn1){
			//ファイル１読み込み
			ncheck=0;
			btn4.setIcon(new ImageIcon("icons/check"+ncheck+".png"));
			text1="";
			ta1.setText("");		
			text3="";
			ta3.setText(text3);
			fileChooserDialog1();
			if (selectedFilePath1.equals("")) {
				text1="もう一度最初からやり直して下さい。\n";
			} else {
				execute=0;
				
				File dir = new File(selectedFilePath1);
				
				String[] files = dir.list();
				int ct=0;
			    for (int i = 0; i < files.length; i++) {
			        String file = files[i];
			        String[] fns=file.split("/");
			        int nf=fns.length;
			        lastFileName1=fns[nf-1];
			        //ファイル読み込み
			        selectedFileName1=selectedFilePath1+"/"+files[i];
			       
			        list1[ct]= lastFileName1;
		        	text1+=lastFileName1+"\n";
					ct++;
			    }
			    files1=ct;
				label1.setText(selectedFilePath1);
				text1+=files1+"個のファイルが見つかりました。\n";
			}
			ta1.setText(text1);
		} else if(e.getSource()==btn2){
			//ファイル２読み込み
			ncheck=0;
			btn4.setIcon(new ImageIcon("icons/check"+ncheck+".png"));
			text2="";
			ta2.setText("");		
			text3="";
			ta3.setText(text3);
			fileChooserDialog2();
			if (selectedFilePath2.equals("")) {
				text2+="もう一度最初からやり直して下さい。\n";
			} else {
				File dir = new File(selectedFilePath2);
				
				String[] files = dir.list();
				//BufferedImage image1=null;
				int ct=0;
				//lSize=0;
			    for (int i = 0; i < files.length; i++) {
			        String file = files[i];
			        String[] fns=file.split("/");
			        int nf=fns.length;
			        lastFileName2=fns[nf-1];
			        //ファイル読み込み
			        selectedFileName2=selectedFilePath1+"/"+files[i];
			       
			        list2[ct]= lastFileName2;
			        text2+=lastFileName2+"\n";
					ct++;
			    }
			    files2=ct;
				label2.setText(selectedFilePath2);
				text2+=files2+"個のファイルが見つかりました。\n";
			}
			ta2.setText(text2);
			
		} else if (e.getSource() == btn3){
			//ベリファイ
			text3="";
			ta3.setText("");
			if (files1==0 || files2==0 ){
				text3="フォルダ選択ボタンを押して\n２つのフォルダを確定して下さい。\n";			
			} else {
				String res="";
				long ct1=0;
				long ct2=0;
				for (int c1=0; c1<files1; c1++){				
					File f1=new File(selectedFilePath1+"/"+list1[c1]);
					ct1=f1.length();
					if (ncheck==0) text3+="1>"+list1[c1]+"　("+ct1+"バイト)\n";
					if (ncheck==1) text3+=list1[c1]+"　(1>"+ct1+"バイト,";
					res="";
					for (int c2=0; c2<files2; c2++){					
						if(ncheck==0 || (list1[c1].equals(list2[c2]) && ncheck==1) ){

							File f2=new File(selectedFilePath2+"/"+list2[c2]);
							ct2=f2.length();					
							if(ncheck==0) text3+="　2>"+list2[c2]+"　("+ct2+"バイト)";
							if(ncheck==1) text3+="2>"+ct2+"バイト)";
							if (ct1!=ct2) {
								res="　相違\n";
							} else {
								try {
									int val1,val2;
									int valError=0;
									//ファイル1を読み込む
									FileInputStream fis1 = new FileInputStream(selectedFilePath1+"/"+list1[c1]);
									//ファイル2を読み込む
									FileInputStream fis2 = new FileInputStream(selectedFilePath2+"/"+list2[c2]);
									for (int i=0; i<ct1; i++){
										val1=fis1.read();
										val2=fis2.read();
										if (val1!=val2) valError++;
									}
									fis1.close();
									fis2.close();
									if (valError>0) res="　相違\n"; else res="　同一\n";
								} catch (IOException ex) {
									//例外発生時処理
									ex.printStackTrace();
								}
							}
							text3+=res;
						}
					}
					if (res.equals("")) text3+="2>同名なし)\n";
					ta3.setText(text3);
				}
			}
		} else if(e.getSource() == btn4){
			ncheck=1-ncheck;
			btn4.setIcon(new ImageIcon("icons/check"+ncheck+".png"));
			
		}
	}
	
	//フォルダ１の読み込み
	public void fileChooserDialog1(){
		selectedFilePath1 = "";
		selectedFileName1 = "";
		JFileChooser fc1 = new JFileChooser( "." );
		fc1.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc1.setFileHidingEnabled(true);
		int result1 = fc1.showOpenDialog(this);
		
		if(result1==JFileChooser.APPROVE_OPTION) {
			selectedFilePath1 = fc1.getSelectedFile().getPath();
			selectedFolderName1 = fc1.getSelectedFile().getName();
		}
		if(result1==JFileChooser.CANCEL_OPTION) {
		}
		if(result1==JFileChooser.ERROR_OPTION) {
		}
	}
	
	//フォルダ２の読み込み 
	public void fileChooserDialog2(){
		selectedFilePath2 = "";
		selectedFileName2 = "";
		JFileChooser fc2 = new JFileChooser( "." );
		fc2.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc2.setFileHidingEnabled(true);
		int result2 = fc2.showOpenDialog(this);		
		if(result2==JFileChooser.APPROVE_OPTION) {
			selectedFilePath2 = fc2.getSelectedFile().getPath();
			selectedFolderName2 = fc2.getSelectedFile().getName();
		}
		if(result2==JFileChooser.CANCEL_OPTION) {
		}
		if(result2==JFileChooser.ERROR_OPTION) {
		}
	}
	
	//ファイルから画像を読み込む
	public BufferedImage getImage(String filename){
		BufferedImage image = null;
		try {
			image = ImageIO.read(new File(filename));
		} catch (Exception e) { 
		}
		return image;
	}
	
	
    //ウインドウの終了ダイアログの表示
	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(FileVerifier.this, "終了しますか？");
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
}
	



